# Certificate Authority API

The Certificate Authority Service API is a highly-available, scalable service that enables you to simplify and automate the management of private certificate authorities (CAs) while staying in control of your private keys.

- [REST Resource: v1.projects.locations](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest#v1.projects.locations)
- [REST Resource: v1.projects.locations.caPools](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest#v1.projects.locations.caPools)
- [REST Resource: v1.projects.locations.caPools.certificateAuthorities](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest#v1.projects.locations.caPools.certificateAuthorities)
- [REST Resource:
  v1.projects.locations.caPools.certificateAuthorities.certificateRevocationLists](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest#v1.projects.locations.caPools.certificateAuthorities.certificateRevocationLists)
- [REST Resource: v1.projects.locations.caPools.certificates](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest#v1.projects.locations.caPools.certificates)
- [REST Resource: v1.projects.locations.certificateTemplates](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest#v1.projects.locations.certificateTemplates)
- [REST Resource: v1.projects.locations.operations](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest#v1.projects.locations.operations)

## Service: privateca.googleapis.com

To call this service, we recommend that you use the Google-provided [client libraries](https://cloud.google.com/apis/docs/client-libraries-explained). If your application needs to use your own libraries to call this service, use the following information when you make the API requests.

### Discovery document

A [Discovery Document](https://developers.google.com/discovery/v1/reference/apis) is a machine-readable specification for describing and consuming REST APIs. It is used to build client libraries, IDE plugins, and other tools that interact with Google APIs. One service may provide multiple discovery documents. This service provides the following discovery document:

- <https://privateca.googleapis.com/$discovery/rest?version=v1>

### Service endpoint

A [service endpoint](https://cloud.google.com/apis/design/glossary#api_service_endpoint) is a base URL that specifies the network address of an API service. One service might have multiple service endpoints. This service has the following service endpoint and all URIs below are relative to this service endpoint:

- `https://privateca.googleapis.com`

## REST Resource: [v1.projects.locations](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations/get` | `GET /v1/{name=projects/*/locations/*}` Gets information about a location. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations/list` | `GET /v1/{name=projects/*}/locations` Lists information about the supported locations for this service. |

## REST Resource: [v1.projects.locations.caPools](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools/create` | `POST /v1/{parent=projects/*/locations/*}/caPools` Create a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools/delete` | `DELETE /v1/{name=projects/*/locations/*/caPools/*}` Delete a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools/fetchCaCerts` | `POST /v1/{caPool=projects/*/locations/*/caPools/*}:fetchCaCerts` FetchCaCerts returns the current trust anchor for the `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools/get` | `GET /v1/{name=projects/*/locations/*/caPools/*}` Returns a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools/getIamPolicy` | `GET /v1/{resource=projects/*/locations/*/caPools/*}:getIamPolicy` Gets the access control policy for a resource. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools/list` | `GET /v1/{parent=projects/*/locations/*}/caPools` Lists `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools/patch` | `PATCH /v1/{caPool.name=projects/*/locations/*/caPools/*}` Update a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools/setIamPolicy` | `POST /v1/{resource=projects/*/locations/*/caPools/*}:setIamPolicy` Sets the access control policy on the specified resource. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools/testIamPermissions` | `POST /v1/{resource=projects/*/locations/*/caPools/*}:testIamPermissions` Returns permissions that a caller has on the specified resource. |

## REST Resource: [v1.projects.locations.caPools.certificateAuthorities](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/activate` | `POST /v1/{name=projects/*/locations/*/caPools/*/certificateAuthorities/*}:activate` Activate a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority` that is in state `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#State.ENUM_VALUES.AWAITING_USER_ACTIVATION` and is of type `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#Type.ENUM_VALUES.SUBORDINATE`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/create` | `POST /v1/{parent=projects/*/locations/*/caPools/*}/certificateAuthorities` Create a new `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority` in a given Project and Location. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/delete` | `DELETE /v1/{name=projects/*/locations/*/caPools/*/certificateAuthorities/*}` Delete a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/disable` | `POST /v1/{name=projects/*/locations/*/caPools/*/certificateAuthorities/*}:disable` Disable a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/enable` | `POST /v1/{name=projects/*/locations/*/caPools/*/certificateAuthorities/*}:enable` Enable a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/fetch` | `GET /v1/{name=projects/*/locations/*/caPools/*/certificateAuthorities/*}:fetch` Fetch a certificate signing request (CSR) from a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority` that is in state `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#State.ENUM_VALUES.AWAITING_USER_ACTIVATION` and is of type `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#Type.ENUM_VALUES.SUBORDINATE`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/get` | `GET /v1/{name=projects/*/locations/*/caPools/*/certificateAuthorities/*}` Returns a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/list` | `GET /v1/{parent=projects/*/locations/*/caPools/*}/certificateAuthorities` Lists `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/patch` | `PATCH /v1/{certificateAuthority.name=projects/*/locations/*/caPools/*/certificateAuthorities/*}` Update a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities/undelete` | `POST /v1/{name=projects/*/locations/*/caPools/*/certificateAuthorities/*}:undelete` Undelete a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities#CertificateAuthority` that has been deleted. |

## REST Resource: [v1.projects.locations.caPools.certificateAuthorities.certificateRevocationLists](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists/get` | `GET /v1/{name=projects/*/locations/*/caPools/*/certificateAuthorities/*/certificateRevocationLists/*}` Returns a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists#CertificateRevocationList`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists/getIamPolicy` | `GET /v1/{resource=projects/*/locations/*/caPools/*/certificateAuthorities/*/certificateRevocationLists/*}:getIamPolicy` Gets the access control policy for a resource. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists/list` | `GET /v1/{parent=projects/*/locations/*/caPools/*/certificateAuthorities/*}/certificateRevocationLists` Lists `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists#CertificateRevocationList`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists/patch` | `PATCH /v1/{certificateRevocationList.name=projects/*/locations/*/caPools/*/certificateAuthorities/*/certificateRevocationLists/*}` Update a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists#CertificateRevocationList`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists/setIamPolicy` | `POST /v1/{resource=projects/*/locations/*/caPools/*/certificateAuthorities/*/certificateRevocationLists/*}:setIamPolicy` Sets the access control policy on the specified resource. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificateAuthorities.certificateRevocationLists/testIamPermissions` | `POST /v1/{resource=projects/*/locations/*/caPools/*/certificateAuthorities/*/certificateRevocationLists/*}:testIamPermissions` Returns permissions that a caller has on the specified resource. |

## REST Resource: [v1.projects.locations.caPools.certificates](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/create` | `POST /v1/{parent=projects/*/locations/*/caPools/*}/certificates` Create a new `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate` in a given Project, Location from a particular `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools#CaPool`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/get` | `GET /v1/{name=projects/*/locations/*/caPools/*/certificates/*}` Returns a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/list` | `GET /v1/{parent=projects/*/locations/*/caPools/*}/certificates` Lists `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/patch` | `PATCH /v1/{certificate.name=projects/*/locations/*/caPools/*/certificates/*}` Update a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates/revoke` | `POST /v1/{name=projects/*/locations/*/caPools/*/certificates/*}:revoke` Revoke a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.caPools.certificates#Certificate`. |

## REST Resource: [v1.projects.locations.certificateTemplates](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates/create` | `POST /v1/{parent=projects/*/locations/*}/certificateTemplates` Create a new `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates#CertificateTemplate` in a given Project and Location. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates/delete` | `DELETE /v1/{name=projects/*/locations/*/certificateTemplates/*}` DeleteCertificateTemplate deletes a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates#CertificateTemplate`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates/get` | `GET /v1/{name=projects/*/locations/*/certificateTemplates/*}` Returns a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates#CertificateTemplate`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates/getIamPolicy` | `GET /v1/{resource=projects/*/locations/*/certificateTemplates/*}:getIamPolicy` Gets the access control policy for a resource. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates/list` | `GET /v1/{parent=projects/*/locations/*}/certificateTemplates` Lists `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates#CertificateTemplate`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates/patch` | `PATCH /v1/{certificateTemplate.name=projects/*/locations/*/certificateTemplates/*}` Update a `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates#CertificateTemplate`. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates/setIamPolicy` | `POST /v1/{resource=projects/*/locations/*/certificateTemplates/*}:setIamPolicy` Sets the access control policy on the specified resource. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.certificateTemplates/testIamPermissions` | `POST /v1/{resource=projects/*/locations/*/certificateTemplates/*}:testIamPermissions` Returns permissions that a caller has on the specified resource. |

## REST Resource: [v1.projects.locations.operations](https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.operations)

| Methods ||
|---|---|
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.operations/cancel` | `POST /v1/{name=projects/*/locations/*/operations/*}:cancel` Starts asynchronous cancellation on a long-running operation. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.operations/delete` | `DELETE /v1/{name=projects/*/locations/*/operations/*}` Deletes a long-running operation. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.operations/get` | `GET /v1/{name=projects/*/locations/*/operations/*}` Gets the latest state of a long-running operation. |
| `https://docs.cloud.google.com/certificate-authority-service/docs/reference/rest/v1/projects.locations.operations/list` | `GET /v1/{name=projects/*/locations/*}/operations` Lists operations that match the specified filter in the request. |